Welcome to Subscribe On Youtube

Formatted question description: https://leetcode.ca/all/1334.html

1334. Find the City With the Smallest Number of Neighbors at a Threshold Distance (Medium)

There are n cities numbered from 0 to n-1. Given the array edges where edges[i] = [fromi, toi, weighti] represents a bidirectional and weighted edge between cities fromi and toi, and given the integer distanceThreshold.

Return the city with the smallest number of cities that are reachable through some path and whose distance is at most distanceThreshold, If there are multiple such cities, return the city with the greatest number.

Notice that the distance of a path connecting cities i and j is equal to the sum of the edges' weights along that path.

 

Example 1:

Input: n = 4, edges = [[0,1,3],[1,2,1],[1,3,4],[2,3,1]], distanceThreshold = 4
Output: 3
Explanation: The figure above describes the graph. 
The neighboring cities at a distanceThreshold = 4 for each city are:
City 0 -> [City 1, City 2] 
City 1 -> [City 0, City 2, City 3] 
City 2 -> [City 0, City 1, City 3] 
City 3 -> [City 1, City 2] 
Cities 0 and 3 have 2 neighboring cities at a distanceThreshold = 4, but we have to return city 3 since it has the greatest number.

Example 2:

Input: n = 5, edges = [[0,1,2],[0,4,8],[1,2,3],[1,4,2],[2,3,1],[3,4,1]], distanceThreshold = 2
Output: 0
Explanation: The figure above describes the graph. 
The neighboring cities at a distanceThreshold = 2 for each city are:
City 0 -> [City 1] 
City 1 -> [City 0, City 4] 
City 2 -> [City 3, City 4] 
City 3 -> [City 2, City 4]
City 4 -> [City 1, City 2, City 3] 
The city 0 has 1 neighboring city at a distanceThreshold = 2.

 

Constraints:

  • 2 <= n <= 100
  • 1 <= edges.length <= n * (n - 1) / 2
  • edges[i].length == 3
  • 0 <= fromi < toi < n
  • 1 <= weighti, distanceThreshold <= 10^4
  • All pairs (fromi, toi) are distinct.

Related Topics:
Graph

Solution 1.

  • class Solution {
        public int findTheCity(int n, int[][] edges, int distanceThreshold) {
            Map<Integer, List<int[]>> distancesMap = new HashMap<Integer, List<int[]>>();
            for (int[] edge : edges) {
                int city1 = edge[0], city2 = edge[1], distance = edge[2];
                List<int[]> list1 = distancesMap.getOrDefault(city1, new ArrayList<int[]>());
                List<int[]> list2 = distancesMap.getOrDefault(city2, new ArrayList<int[]>());
                list1.add(new int[]{city2, distance});
                list2.add(new int[]{city1, distance});
                distancesMap.put(city1, list1);
                distancesMap.put(city2, list2);
            }
            int[] reachableCounts = new int[n];
            for (int i = 0; i < n; i++) {
                int[] distances = getDistance(n, i, distancesMap);
                for (int distance : distances) {
                    if (distance > 0 && distance <= distanceThreshold)
                        reachableCounts[i]++;
                }
            }
            int minReachable = n - 1;
            for (int i = 0; i < n; i++)
                minReachable = Math.min(minReachable, reachableCounts[i]);
            int cityIndex = 0;
            for (int i = n - 1; i >= 0; i--) {
                if (reachableCounts[i] == minReachable) {
                    cityIndex = i;
                    break;
                }
            }
            return cityIndex;
        }
    
        public int[] getDistance(int n, int source, Map<Integer, List<int[]>> distancesMap) {
            int[] distances = new int[n];
            for (int i = 0; i < n; i++)
                distances[i] = Integer.MAX_VALUE;
            distances[source] = 0;
            PriorityQueue<CityDistance> priorityQueue = new PriorityQueue<CityDistance>();
            priorityQueue.offer(new CityDistance(source, 0));
            while (!priorityQueue.isEmpty()) {
                CityDistance cityDistance = priorityQueue.poll();
                int city = cityDistance.city, distance = cityDistance.distance;
                if (distance > distances[city])
                    continue;
                List<int[]> adjacentCities = distancesMap.getOrDefault(city, new ArrayList<int[]>());
                for (int[] adjacentCity : adjacentCities) {
                    int nextCity = adjacentCity[0], nextDistance = adjacentCity[1];
                    int newDistance = distance + nextDistance;
                    if (newDistance < distances[nextCity]) {
                        distances[nextCity] = newDistance;
                        priorityQueue.offer(new CityDistance(nextCity, newDistance));
                    }
                }
            }
            return distances;
        }
    }
    
    class CityDistance implements Comparable<CityDistance> {
        public int city;
        public int distance;
    
        public CityDistance(int city, int distance) {
            this.city = city;
            this.distance = distance;
        }
    
        public int compareTo(CityDistance cityDistance2) {
            return this.distance - cityDistance2.distance;
        }
    }
    
    ############
    
    class Solution {
        private int n;
        private int[][] g;
        private int[] dist;
        private boolean[] vis;
        private int inf = 1 << 30;
        private int distanceThreshold;
    
        public int findTheCity(int n, int[][] edges, int distanceThreshold) {
            this.n = n;
            this.distanceThreshold = distanceThreshold;
            g = new int[n][n];
            dist = new int[n];
            vis = new boolean[n];
            for (var e : g) {
                Arrays.fill(e, inf);
            }
            for (var e : edges) {
                int f = e[0], t = e[1], w = e[2];
                g[f][t] = w;
                g[t][f] = w;
            }
            int ans = n, t = inf;
            for (int i = n - 1; i >= 0; --i) {
                int cnt = dijkstra(i);
                if (t > cnt) {
                    t = cnt;
                    ans = i;
                }
            }
            return ans;
        }
    
        private int dijkstra(int u) {
            Arrays.fill(dist, inf);
            Arrays.fill(vis, false);
            dist[u] = 0;
            for (int i = 0; i < n; ++i) {
                int k = -1;
                for (int j = 0; j < n; ++j) {
                    if (!vis[j] && (k == -1 || dist[k] > dist[j])) {
                        k = j;
                    }
                }
                vis[k] = true;
                for (int j = 0; j < n; ++j) {
                    dist[j] = Math.min(dist[j], dist[k] + g[k][j]);
                }
            }
            int cnt = 0;
            for (int d : dist) {
                if (d <= distanceThreshold) {
                    ++cnt;
                }
            }
            return cnt;
        }
    }
    
  • // OJ: https://leetcode.com/problems/find-the-city-with-the-smallest-number-of-neighbors-at-a-threshold-distance/
    // Time: O(V * (E + VlogV))
    // Space: O(E)
    class Solution {
        typedef pair<int, int> iPair; 
        unordered_map<int, vector<iPair>> graph;
        int th, N, minNum = INT_MAX;
        int dijkstra(int i) {
            priority_queue<iPair, vector<iPair>, greater<iPair>> q;
            vector<int> dist(N, INT_MAX);
            q.push(make_pair(0, i));
            dist[i] = 0;
            while (q.size()) {
                int u = q.top().second;
                q.pop();
                for (auto ne : graph[u]) {
                    int v = ne.first;
                    int w = ne.second;
                    if (dist[v] > dist[u] + w) {
                        dist[v] = dist[u] + w;
                        q.push(make_pair(dist[v], v));
                    }
                }
            }
            int cnt = 0;
            for (int j = 0; j < N; ++j) {
                if (j != i && dist[j] <= th) ++cnt;
            }
            return cnt;
        }
    public:
        int findTheCity(int n, vector<vector<int>>& edges, int distanceThreshold) {
            th = distanceThreshold;
            N = n;
            for (auto e : edges) {
                m[e[0]].push_back(make_pair(e[1], e[2]));
                m[e[1]].push_back(make_pair(e[0], e[2]));
            }
            int ans = 0;
            for (int i = 0; i < n; ++i) {
                int cnt = dijkstra(i);
                if (cnt <= minNum) {
                    minNum = cnt;
                    ans = i;
                }
            }
            return ans;
        }
    };
    
  • class Solution:
        def findTheCity(
            self, n: int, edges: List[List[int]], distanceThreshold: int
        ) -> int:
            def dijkstra(u):
                dist = [inf] * n
                dist[u] = 0
                vis = [False] * n
                for _ in range(n):
                    k = -1
                    for j in range(n):
                        if not vis[j] and (k == -1 or dist[k] > dist[j]):
                            k = j
                    vis[k] = True
                    for j in range(n):
                        dist[j] = min(dist[j], dist[k] + g[k][j])
                return sum(d <= distanceThreshold for d in dist)
    
            g = [[inf] * n for _ in range(n)]
            for f, t, w in edges:
                g[f][t] = g[t][f] = w
    
            ans = n
            t = inf
            for i in range(n - 1, -1, -1):
                if (cnt := dijkstra(i)) < t:
                    t = cnt
                    ans = i
            return ans
    
    
  • func findTheCity(n int, edges [][]int, distanceThreshold int) int {
    	g := make([][]int, n)
    	dist := make([]int, n)
    	vis := make([]bool, n)
    	const inf int = 1e7
    	for i := range g {
    		g[i] = make([]int, n)
    		for j := range g[i] {
    			g[i][j] = inf
    		}
    	}
    	for _, e := range edges {
    		f, t, w := e[0], e[1], e[2]
    		g[f][t], g[t][f] = w, w
    	}
    
    	ans, t := n, inf
    	dijkstra := func(u int) (cnt int) {
    		for i := range vis {
    			vis[i] = false
    			dist[i] = inf
    		}
    		dist[u] = 0
    		for i := 0; i < n; i++ {
    			k := -1
    			for j := 0; j < n; j++ {
    				if !vis[j] && (k == -1 || dist[j] < dist[k]) {
    					k = j
    				}
    			}
    			vis[k] = true
    			for j := 0; j < n; j++ {
    				dist[j] = min(dist[j], dist[k]+g[k][j])
    			}
    		}
    		for _, d := range dist {
    			if d <= distanceThreshold {
    				cnt++
    			}
    		}
    		return
    	}
    	for i := n - 1; i >= 0; i-- {
    		cnt := dijkstra(i)
    		if t > cnt {
    			t = cnt
    			ans = i
    		}
    	}
    	return ans
    }
    
    func min(a, b int) int {
    	if a < b {
    		return a
    	}
    	return b
    }
    

All Problems

All Solutions